import { CanvasObject } from "./GameObject";
import Canvas from "./Canvas";
import { MapType, NodeType } from "../common-types";
export declare class Grid extends CanvasObject {
    width: number;
    height: number;
    cells: MapType;
    constructor();
    updateCell: (x: number, y: number, data: Partial<NodeType>, canvas: Canvas, gridColor: string) => void;
    drawCell: (canvas: Canvas) => (params: {
        x: number;
        y: number;
        strokeStyle?: string;
    }) => void;
    draw: (canvas: Canvas) => void;
}
export default Grid;
