import { CanvasObject } from "../../components/GameObject";
export declare type IChangeStateFields = ({ dX, dY, isLast }: {
    dX: number;
    dY: number;
    isLast?: boolean;
}) => object;
export declare type IRunContext = (changeStateFields: IChangeStateFields) => IRun;
export declare type IRun = ({ x: toX, y: toY }: {
    x: number;
    y: number;
}) => void;
export declare enum ERunType {
    Diagonal = "diagonal",
    Cathet = "cathet",
    SmartCathet = "smart-cathet"
}
export declare type Constructor = new (...args: any[]) => CanvasObject;
