import { CanvasObject } from "./GameObject";
import Canvas from "./Canvas";
declare const CELL_VIEWS: {
    normal: {
        fillStyle: string;
    };
    hover: {
        fillStyle: string;
    };
    click: {
        fillStyle: string;
    };
};
export declare class Cell extends CanvasObject<{
    currentView: keyof typeof CELL_VIEWS;
}> {
    static height: number;
    static width: number;
    x: number;
    y: number;
    disabled: boolean;
    constructor({ x, y, disabled }: {
        x: number;
        y: number;
        disabled?: boolean;
    });
    draw: (canvas: Canvas) => void;
}
export default Cell;
